;;; Test program for 512B OS ;;;

format MZ
use16
jmp start

mes1	db 'Hello, this is a test DOS MZ-EXE which uses INT 10h',13,10
	db 'for string printing, because there''s no DOS here and',13,10
	db 'if this program is loaded through Tiny-D0S, the only DOS',13,10
	db 'function emulated is AH=4Ch INT 21h which points to 0:7c00h',13,10
	db 'thus restarting Tiny-D0S from RAM',13,10,13,10
	db 'Made for "Second 512 byte OS contest"',13,10
	db 'Press any key to exit. --Inflater from OSdev.org',13,10,0

start:
	push cs
	pop ds
	mov si,mes1			;Display the message
	call printstring		;through INT 10h - BIOS
	xor ax,ax			;Wait for keypress
	int 16h
	mov ah,4Ch			;INT 21h - restart this time :)
	int 21h				;Actually INT 21h points to "reboot"
					;whatever the parameter is. Space saving! :)	

printstring:		
	mov ah,0eh
stringloop:
	lodsb
	cmp al,00
	je endstring
	int 10h
	jmp stringloop
endstring:
	ret